import java.util.Set;

public class Node {
	
	private Node leftChild;
	private Node rightChild;
	private Node parent;
	private Node speciesLCA;
	private String species;
	private String label;
	private boolean duplication;
	private Set<String> cladeSpecies;
	private Set<String> cladeLabel;
	private Set<String> nodesToPrune1;
	private Set<String> nodesToPrune2;
	private int noNode;
	private int numLeaves;
	private int Mg;
	private boolean B1;
	private boolean B2;
	private boolean B3;
	
	public String toString() { 
	 return this.toString2() + ";";
	}
	public String toString2() {
		if(this.getLeftChild() == null) {
			return species;
		} else {
			return "(" + this.getLeftChild().toString2() + "," + this.getRightChild().toString2() + ")"  
					+this.getSpecies() + (this.isDuplication()? " Dup":""); //000 pour duplication pour voir avec online viewer
		}	
	}
	
	public String toString3() {
		if(this.getLeftChild() == null) {
			return species;
		} else {
			return "(" + this.getLeftChild().toString3() + "," + this.getRightChild().toString3() + ")"; 
		}	
	}
	
	public String toString4() {
		if(this.getLeftChild() == null) {
			return label;
		} else {
			return "(" + this.getLeftChild().toString4() + "," + this.getRightChild().toString4() + ")"; 
		}	
	}
	public boolean isDuplication() {
		return duplication;
	}
	public void setDuplication(boolean duplication) {
		this.duplication = duplication;
	}

	public Node getParent() {
		return parent;
	}
	public void setParent(Node parent) {
		this.parent = parent;
	}
	public int getNoNode() {
		return noNode;
	}
	public void setNoNode(int noNode) {
		this.noNode = noNode;
	}
	public int getNumLeaves() {
		return numLeaves;
	}
	public void setNumLeaves(int numLeaves) {
		this.numLeaves = numLeaves;
	}
	public boolean isB1() {
		return B1;
	}
	public void setB1(boolean b1) {
		B1 = b1;
	}
	public boolean isB2() {
		return B2;
	}
	public void setB2(boolean b2) {
		B2 = b2;
	}
	public boolean isB3() {
		return B3;
	}
	public void setB3(boolean b3) {
		B3 = b3;
	}
	public Node getSpeciesLCA() {
		return speciesLCA;
	}
	public void setSpeciesLCA(Node speciesLCA) {
		this.speciesLCA = speciesLCA;
	}
	public int getMg() {
		return Mg;
	}
	public void setMg(int mg) {
		Mg = mg;
	}
	public String getSpecies() {
		return species;
	}
	public void setSpecies(String species) {
		this.species = species;
	}
	public Set<String> getCladeSpecies() {
		return cladeSpecies;
	}
	public void setCladeSpecies(Set<String> cladeSpecies) {
		this.cladeSpecies = cladeSpecies;
	}
	public Node getRightChild() {
		return rightChild;
	}
	public void setRightChild(Node rightChild) {
		this.rightChild = rightChild;
	}
	public Node getLeftChild() {
		return leftChild;
	}
	public void setLeftChild(Node leftChild) {
		this.leftChild = leftChild;
	}
	public String getLabel() {
		return label;
	}
	public void setLabel(String label) {
		this.label = label;
	}
	public Set<String> getCladeLabel() {
		return cladeLabel;
	}
	public void setCladeLabel(Set<String> cladeLabel) {
		this.cladeLabel = cladeLabel;
	}
	public Set<String> getNodesToPrune1() {
		return nodesToPrune1;
	}
	public void setNodesToPrune1(Set<String> nodeToPrune1) {
		this.nodesToPrune1 = nodeToPrune1;
	}
	public Set<String> getNodesToPrune2() {
		return nodesToPrune2;
	}
	public void setNodesToPrune2(Set<String> nodeToPrune2) {
		this.nodesToPrune2 = nodeToPrune2;
	}

}
